/***********************************************************************
/*  Name: Exp_ODI_Framework
/*  Description: Setup the ODI framework, run in EXPR_INTEGRATION
/* Modification History: 
/* Date      Name                Modification Description
/* --------  -----------------   -------------------------------------
/* 
/**********************************************************************/
drop table exp_odi_application;
CREATE TABLE EXP_ODI_APPLICATION
 (APPLICATION_CODE VARCHAR2(3) NOT NULL
 ,APPLICATION_NAME VARCHAR2(50) NOT NULL
 ,LAST_UPDATE_ID VARCHAR2(80)
 ,LAST_UPDATE_DATETIME DATE 
 ,CONSTRAINT exp_odi_app_pk PRIMARY KEY (APPLICATION_CODE)
 )
 INITRANS 6
 STORAGE
 (
   FREELISTS 6
 );
 
 
 drop table exp_odi_pattern;
CREATE TABLE EXP_ODI_PATTERN
 (PATTERN_TYPE VARCHAR2(3) NOT NULL
 ,DESCRIPTION VARCHAR2(200)
 ,LAST_UPDATE_ID VARCHAR2(80)
 ,LAST_UPDATE_DATETIME DATE
 ,CONSTRAINT exp_odi_pattern_pk PRIMARY KEY (PATTERN_TYPE) 
 )
 INITRANS 6
 STORAGE
 (
   FREELISTS 6
 ); 
 
 drop table exp_odi_interface;
CREATE TABLE EXP_ODI_INTERFACE
 (INTERFACE_ID VARCHAR2(20) NOT NULL
 ,DESCRIPTION VARCHAR2(200)
 ,SOURCE_APP  VARCHAR2(3)
 ,TARGET_APP VARCHAR2(3)
 ,PATTERN_TYPE   VARCHAR2(3)
 ,LAST_UPDATE_ID VARCHAR2(80)
 ,LAST_UPDATE_DATETIME DATE 
 ,CONSTRAINT exp_odi_intf_pk PRIMARY KEY (INTERFACE_ID)
 ,CONSTRAINT src_app_eoi_fk
    FOREIGN KEY (SOURCE_APP)
    REFERENCES EXP_ODI_APPLICATION(APPLICATION_CODE)
 ,CONSTRAINT tgt_app_eoi_fk
    FOREIGN KEY (TARGET_APP)
    REFERENCES EXP_ODI_APPLICATION(APPLICATION_CODE)	
 ,CONSTRAINT pattern_type_eoi_eop_fk
    FOREIGN KEY (PATTERN_TYPE)
    REFERENCES EXP_ODI_PATTERN(PATTERN_TYPE)		
 )
 INITRANS 6
 STORAGE
 (
   FREELISTS 6
 );
 
 
  
 drop table exp_odi_pattern_param;
CREATE TABLE EXP_ODI_PATTERN_PARAM
 (PATTERN_TYPE VARCHAR2(3) NOT NULL
 ,PARAM_NAME VARCHAR2(100)
 ,DESCRIPTION VARCHAR2(200)
 ,REQUIRED_FLAG VARCHAR2(1)
 ,PARAM_TYPE VARCHAR2(1) --'N'umber, 'V'archar, 'D'ate
 ,LAST_UPDATE_ID VARCHAR2(80)
 ,LAST_UPDATE_DATETIME DATE
 ,CONSTRAINT exp_odi_patt_param_pk PRIMARY KEY (PATTERN_TYPE, PARAM_NAME) 
 ,CONSTRAINT pattern_type_eop_eopp_fk
    FOREIGN KEY (PATTERN_TYPE)
    REFERENCES EXP_ODI_PATTERN(PATTERN_TYPE)
 )
 INITRANS 6
 STORAGE
 (
   FREELISTS 6
 ); 

 drop table exp_odi_interface_param;
CREATE TABLE EXP_ODI_INTERFACE_PARAM
 (INTERFACE_ID VARCHAR2(20) NOT NULL
 ,PATTERN_TYPE VARCHAR2(3) NOT NULL 
 ,PARAM_NAME VARCHAR2(100)
 ,PARAM_VALUE VARCHAR2(255)
 ,LAST_UPDATE_ID VARCHAR2(80)
 ,LAST_UPDATE_DATETIME TIMESTAMP
 ,CONSTRAINT exp_odi_intfparm_pk PRIMARY KEY (INTERFACE_ID,PATTERN_TYPE,PARAM_NAME)
 ,CONSTRAINT interface_id_eoi_eop_fk
    FOREIGN KEY (INTERFACE_ID)
    REFERENCES EXP_ODI_INTERFACE(INTERFACE_ID) 
 ,CONSTRAINT param_name_eopp_eoip_fk
    FOREIGN KEY (pattern_type, param_name)
    REFERENCES EXP_ODI_PATTERN_PARAM(PATTERN_TYPE, PARAM_NAME) 	
 )
 INITRANS 6
 STORAGE
 (
   FREELISTS 6
 ); 


CREATE PUBLIC SYNONYM EXP_ODI_APPLICATION FOR EXPR_INTERFACE.EXP_ODI_APPLICATION;
CREATE PUBLIC SYNONYM EXP_ODI_INTERFACE FOR EXPR_INTERFACE.EXP_ODI_INTERFACE;
CREATE PUBLIC SYNONYM EXP_ODI_PATTERN FOR EXPR_INTERFACE.EXP_ODI_PATTERN;
CREATE PUBLIC SYNONYM EXP_ODI_PATTERN_PARAM FOR EXPR_INTERFACE.EXP_ODI_PATTERN_PARAM;
CREATE PUBLIC SYNONYM EXP_ODI_INTERFACE_PARAM FOR EXPR_INTERFACE.EXP_ODI_INTERFACE_PARAM;
CREATE PUBLIC SYNONYM EXP_ODI_APPLICATION FOR EXPR_INTERFACE.EXP_ODI_APPLICATION;


--12/5/2013 update to column size:

-- EXP_ODI_INTERFACE
-- EXP_ODI_INTERFACE_PARAM

ALTER TABLE 
   EXP_ODI_INTERFACE 
MODIFY 
   ( 
   INTERFACE_ID varchar2(50)
   )
;

ALTER TABLE 
   EXP_ODI_INTERFACE_PARAM 
MODIFY 
   ( 
   INTERFACE_ID varchar2(50)
   )
;
